%global debug_package %{nil}

%define author Gábor Lénárt <lgblgblgb@gmail.com>
%define build_timestamp %{lua: print(os.date("%Y%m%d"))}
%define project xemu
%define branch next
## git rev-parse HEAD
%define rev 4b62b108cb0fbb3141db482e04fb357135462e94

Name: x-emulators
Version: %{build_timestamp}
Release: %{rev}%{?dist}
Summary: X-Emulators is a collection of software emulations of some (mainly 8 bit) computers
Source: https://github.com/lgblgblgb/xemu/archive/%{rev}.tar.gz#/%{name}-%{version}.tar.gz
URL: https://github.com/lgblgblgb/xemu
License: GPLv2
Group: Applications/Emulators

Requires: SDL2
Requires: readline
Requires: gtk3

BuildRequires: make
BuildRequires: coreutils
BuildRequires: gcc
BuildRequires: glib2-devel
BuildRequires: harfbuzz-devel
BuildRequires: cairo-devel
BuildRequires: pango-devel
BuildRequires: SDL2-devel
BuildRequires: readline-devel
BuildRequires: gtk3-devel
%if 0%{?is_opensuse}
BuildRequires: gdk-pixbuf-devel
%endif
%if 0%{?mageia}
BuildRequires: %mklibname -d gdk_pixbuf 2.0
%endif
%if 0%{?fedora} || 0%{?rhel}
BuildRequires: gdk-pixbuf2-devel
%endif

BuildRoot: %{_tmppath}/%{name}-buildroot

%description
X-Emulators (Xemu) is a kind of collection of software emulators
targeting various computers, including the quite rare Commodore LCD,
Commodore 65, and MEGA65 as well. Xemu uses SDL2, and can run on Linux/UNIX,
Windows and MacOS, also there is the limited possibility to use it within a
web-browser with the help of the Emscripten compiler.

%prep
%autosetup -n %{project}-%{rev}

%build
%{make_build} clean
%{make_build} config
%{make_build} all


%install
rm -rf %{buildroot}
install -m 0755 -d %{buildroot}%{_bindir}
install -m 0755 -d %{buildroot}%{_datarootdir}
install -m 0755 -d %{buildroot}%{_datarootdir}/xemu
install -m 0755 -d %{buildroot}%{_datarootdir}/pixmaps
install -m 0755 -d %{buildroot}%{_datarootdir}/applications

install -m 0755 -s build/bin/xc65.native %{buildroot}%{_bindir}/xemu-xc65
install -m 0755 -s build/bin/xvic20.native %{buildroot}%{_bindir}/xemu-xvic20
install -m 0755 -s build/bin/xclcd.native %{buildroot}%{_bindir}/xemu-xclcd
install -m 0755 -s build/bin/xep128.native %{buildroot}%{_bindir}/xemu-xep128
install -m 0755 -s build/bin/xmega65.native %{buildroot}%{_bindir}/xemu-xmega65
install -m 0755 -s build/bin/xprimo.native %{buildroot}%{_bindir}/xemu-xprimo
install -m 0755 -s build/bin/xtvc.native %{buildroot}%{_bindir}/xemu-xtvc

install -m 0644 build/xemu-48x48.xpm %{buildroot}%{_datarootdir}/pixmaps/xemu-48x48.xpm

for a in targets/*/Makefile ; do
  if [ -s $a ]; then
    prgtarget="`sed -n 's/^PRG_TARGET[\t ]*=[\t ]*//p' $a`"
    machine="`sed -n 's/^EMU_DESCRIPTION[\t ]*=[\t ]*//p' $a`"
    if [ "$prgtarget" != "" -a "$machine" != "" -a -x "build/bin/$prgtarget.native" ]; then
       sed "s/%machine/$machine/g;s/%binary/xemu-$prgtarget/g" build/xemu.desktop >%{buildroot}%{_datarootdir}/applications/xemu-$prgtarget.desktop
    fi
  fi
done

cat >COPYING <<___EOT
(C) %{author}
%{URL}

___EOT
cat LICENSE >>COPYING

%post
update-desktop-database %{_datarootdir}/applications

%files
%defattr(0644, root, root, -)
%license COPYING
%doc README.md AUTHORS LICENSE

%attr(0755, root, root) %{_bindir}/xemu-*

%{_datarootdir}/pixmaps/xemu-48x48.xpm
%{_datarootdir}/applications/xemu-*.desktop
